#!/bin/bash

PASS=bC0HqbQr4Diy0JHq4uyd4szpneYvbbUOEwTrbaWfD
LOG_DIR=/root/innodb-scale-bug-68079

reset () {
	mysql -e "DROP DATABASE bug; CREATE DATABASE bug";
	cat <<SQL | mysql
USE bug;
CREATE TABLE incident (
sys_id char(32) NOT NULL DEFAULT '',
category varchar(40) DEFAULT NULL,
PRIMARY KEY (sys_id),
KEY incident_category (category)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
insert into incident(sys_id) values (rand()*1000000);
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
insert into incident(sys_id) select rand()*1000000 from incident as i2 on duplicate key update incident.sys_id=incident.sys_id*13;
CREATE TABLE task (
sys_id char(32) NOT NULL DEFAULT '',
u_root_cause char(32) DEFAULT NULL,
u_business_impact_description mediumtext,
u_business_impact_category mediumtext,
PRIMARY KEY (sys_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
insert into task(sys_id) values(rand()*1000000);
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
insert into task(sys_id) select rand()*1000000 from task as t2 on duplicate key update task.sys_id=task.sys_id*13;
-- 
insert into task(sys_id) select sys_id from incident limit 100;
--
update incident set category=rand()*100000;
-- show table status like 'task'\G
-- show table status like 'incident'\G
pager cat > /dev/null
select * from task;
select * from incident;
SQL
}


SPIN_WAIT[0]=6;
SPIN_WAIT[1]=12;
SPIN_WAIT[2]=24;
SPIN_WAIT[3]=48;

PARALLEL[0]=1;
PARALLEL[1]=2;
PARALLEL[2]=4;
PARALLEL[3]=8;
PARALLEL[4]=16;
PARALLEL[5]=24;
PARALLEL[6]=32;
PARALLEL[7]=48;


for WAIT in "${SPIN_WAIT[@]}"
do
	LOG=${LOG_DIR}/test-result-spin-wait-${WAIT}.log;
	CURRENT_WAIT="set global innodb_spin_wait_delay = ${WAIT}";
	echo "${CURRENT_WAIT}" > ${LOG}
	echo "=================================================================================" >> ${LOG};
	mysql -e "${CURRENT_WAIT}";

	for PAR in "${PARALLEL[@]}"
	do
		reset > /dev/null;
		CMD="mysqlslap -uroot -p${PASS} --concurrency=${PAR} --create-schema=bug --no-drop --number-of-queries=1000 --iterations=10 --query='select count(*), category from task inner join incident on task.sys_id=incident.sys_id group by incident.category'";
		echo ${CMD} >> ${LOG};
		SAR_FILE=${LOG_DIR}/test-result-spin-wait-${WAIT}-threads-${PAR}.sar
		sar -o ${SAR_FILE} 1 >/dev/null 2>&1 &
		SAR=`jobs -p`;
		mysqlslap -uroot -p${PASS} --concurrency=${PAR} --create-schema=bug --no-drop --number-of-queries=1000 --iterations=10 --query='select count(*), category from task inner join incident on task.sys_id=incident.sys_id group by incident.category' >> ${LOG};
		mysql --table -e "show engine innodb mutex" >> ${LOG};
		echo "=================================================================================" >> ${LOG};
		disown ${SAR};
		kill ${SAR} 1 >/dev/null 2>&1;
		sar -f ${SAR_FILE} > ${SAR_FILE}.txt;
		rm -f ${SAR_FILE};
	done
done


# Build the chart.
echo "Spin: ${PARALLEL[@]}" > ${LOG_DIR}/chart.tmp;
for WAIT in "${SPIN_WAIT[@]}"
do
        LOG=${LOG_DIR}/test-result-spin-wait-${WAIT}.log;
        echo "${WAIT}: `grep Average ${LOG} | grep all | awk '{print $9}' | tr '\n' ' '`" >> ${LOG_DIR}/chart.tmp;
done

echo "                               Threads:" > ${LOG_DIR}/chart.txt;
cat ${LOG_DIR}/chart.tmp | column -t >> ${LOG_DIR}/chart.txt;
rm -f ${LOG_DIR}/chart.tmp
cat ${LOG_DIR}/chart.txt

# Remove hostname from first line of sar output.
perl -pi -e "s/\([a-z0-9\.\-]+\.com\)//g" ${LOG_DIR}/*.sar.txt
